unit Reduce;

interface

uses Syst,FillArrays,DateSyst;
    procedure reduce_f(fun:TFunc2;eqs,vrs:IVector; xx:DVector);
implementation

procedure reduce_f(fun:TFunc2;eqs,vrs:IVector; xx:DVector);
var
a:DDVector;//   
y:DVector;
i,j,k,l:integer;
begin
  SetLength(a,len,len+1);
  SetLength(y,f.Get_s);
  k:=0;
  j:=0;
  for i:=0 to f.Get_r-1 do if (i=vrs[k]) then begin x[i]:=0; k:=k+1; end else begin x[i]:=xx[j]; j:=j+1; end;//       xx ()  
  fun(x);
  y:=f.GetSys;
  for i:=0 to len-1 do a[i,len]:=-y[eqs[i]]; // a[0..s-1,len]   
  for k:=0 to len-1 do
  begin
  x[vrs[k]]:=1;
  fun(x);
  y:=f.GetSys;
  for i:=0 to len-1 do a[i,k]:=y[eqs[i]]+a[i,len]; // a[i,k]       k     i
  x[vrs[k]]:=0;
  end;
  //-------------------------------------------------------------
  for i:=0 to len-1 do
  begin
    k:=0;
    while (a[i,k]=0)and(k<len) do k:=k+1;
    if (k=len) then begin err:='ERROR! The Linear subsystem has a no decisions. Change the initial data.'; exit;end;
    for j:=0 to k-1 do a[i,j]:=a[i,j]/a[i,k];
    for j:=k+1 to len do a[i,j]:=a[i,j]/a[i,k];
    a[i,k]:=1;
    for l:=0 to i-1 do
    begin
      for j:=0 to k-1 do  a[l,j]:=a[l,j]-a[i,j]*a[l,k];
      for j:=k+1 to len do  a[l,j]:=a[l,j]-a[i,j]*a[l,k];
      a[l,k]:=0;
    end;
    for l:=i+1 to len-1 do
    begin
      for j:=0 to k-1 do  a[l,j]:=a[l,j]-a[i,j]*a[l,k];
      for j:=k+1 to len do  a[l,j]:=a[l,j]-a[i,j]*a[l,k];
      a[l,k]:=0;
    end;
  end;                                  //   -      
  //------------------------------------------------------------------
  for i:=0 to len-1 do
  begin
    k:=0;
    while (a[i,k]=0)and(k<len) do k:=k+1;
    x[vrs[k]]:=a[i,len];
  end;     //      
  fun(x);  //    
end;
end.
