unit Syst;

interface
type
  DVector   = array of extended;
  StatDVector = array [0..1] of extended;
  D2Vector  = array of StatDVector;
  DDVector = array of array of extended; 
	IVector   = array of integer;
  B2Vector = array of array of byte;
  B3Vector =  array of array of array of byte;
  BVector = array of byte;
  TFunc1 = procedure;
  TFunc2 = procedure(x:DVector);

  sys = class
  protected
    s,r:integer;
    obldate:D2Vector;
    f:DVector;
  public
    constructor Create(s_:integer;r_:integer;obldate_:D2Vector);
    Destructor  Done;
    procedure PutSys(f_:DVector);
    function GetFun(n_:integer):extended;
    function GetSys():DVector;
    function GetObl(n_:integer):StatDVector;
    function Get_r():integer;
    function Get_s():integer;
  end;
implementation
uses SysUtils, classes, Math;
// class matrix
// ========================================================================
constructor sys.Create(s_:integer;r_:integer;obldate_:D2Vector);
var i:integer;
begin
   s:=s_; r:=r_;
   SetLength(obldate,r_);
   obldate:=copy(obldate_);
   SetLength(f,s_);
end;
//-------------------------------------------------------------------------
Destructor  sys.Done;
begin
	s:=0;
  r:=0;
  obldate:=nil;
  f:=nil;
end;
//-------------------------------------------------------------------------
procedure sys.PutSys(f_:DVector);
begin
if (Length(f_)<>s) then exit;
f:=copy(f_);
end;
//-------------------------------------------------------------------------
function sys.GetFun(n_:integer):extended;
begin
result:=f[n_];
end;
//-------------------------------------------------------------------------
function sys.GetSys():DVector;
begin
result:=f;
end;
//-------------------------------------------------------------------------
function sys.GetObl(n_:integer):StatDVector;
begin
result:=obldate[n_];
end;
//-------------------------------------------------------------------------
function sys.Get_r():integer;
begin
result:=r;
end;
//-------------------------------------------------------------------------
function sys.Get_s():integer;
begin
result:=s;
end;
//-------------------------------------------------------------------------

end.
